unit uInstaller;

interface

uses
  uPattern                        // for TVisitor
  , uHouse                        // for THouse, TWindow, TDoor
  ;

type

  TDoubleGlazingInstaller = class(TVisitor)
  private

  public

    procedure AllowVisitorToDoSomethingTo(Visited: TVisited); override;

  end;

procedure InstallPlasticInThing(Thing: TVisited);

implementation

uses
  graphics                        // for clWhite
  ;

procedure InstallPlasticInThing(Thing: TVisited);
var
  Visitor: TDoubleGlazingInstaller;
begin
  Visitor := TDoubleGlazingInstaller.Create;
  try { ... finally }
    Thing.AcceptVisitFrom(Visitor);
  finally
    Visitor.Free;
  end;  { try ... finally }

end;

{ TDoubleGlazingInstaller }

procedure TDoubleGlazingInstaller.AllowVisitorToDoSomethingTo(
  Visited: TVisited);
begin
  if (Visited is THoleStopper) then
  begin
    THoleStopper(Visited).Material := tmPlastic;
    THoleStopper(Visited).Colour := clWhite;
  end;
end;

end.
 